Attribute VB_Name = "basicutilities"
Option Explicit

'math constant
Public Const Pi As Double = 3.141592654

'string constants
Public cr As String * 1
Public es As String * 1
Public ff As String * 1
Public lf As String * 1
Public nl As String * 2
Public qt As String * 1
Public tb As String * 1
Public bs As String * 1
Public dl As String * 1
Public ack As String * 1
Public nack As String * 1


'ini data array
Public ini(100) As String


'com port status flag
Public startchar As String * 1      'pre portcontroller variable
Public endchar As String * 1        'pre portcontroller variable
Public cmstatus As Boolean          'used by all versions

'serial receive data event mode
'will be "ondemand" or "interrupt"
Public rxmode As String             'pre portcontroller variable
Public rxbuffer As String           'used by all versions
Public commandbuffer As String      'pre portcontroller variable




Public Function inttobin(datain As Integer) As String

Dim dataout As String
Dim i As Integer

For i = 0 To 7
  If (datain And (2 ^ i)) > 0 Then
    dataout = "1" + dataout
  Else
    dataout = "0" + dataout
  End If
Next i

inttobin = dataout

End Function

Public Function word(indata As String, pointer As Long, parser As String) As String
'returns words between spaces if parser is a space:
'     word("__this___is_a__test___",3," ")="a"
'     word("__this___is_a__test___",0," ")="4"
'
'returns items between each parser if other than a space
'     word(",,,this,is_a,test,,",4,",")="this"
'     word(",,,this,is_a,test,,",0,",")="11"
'
'may be nested in use
'     word(word(",,,this,is_a,test,,",5,","),2," ")="a"
'
'null parser and space parser both equate to space
'limited to 8000 items selected or counted
'
'returns leading and trailing characters of type parser
'     word("    this is a test    ",-1," ")="this is a test"

Dim limit As Long
Dim tagcount As Long
Dim itemtag(8000) As Long
Dim lasttag As Long
Dim i As Long
Dim f As Long
Dim n As String * 1
Dim xdata As String

'**********************************************************

limit = 8000

If pointer = -1 Then
  'strip leading and trailing characters
  'must be empty
  If Len(indata) = 0 Then
    word = indata
    Exit Function
  End If
  'strip leading parsers
  xdata = ""
  For i = 1 To Len(indata)
    If Mid(indata, i, 1) <> parser Then
      xdata = Right(indata, Len(indata) - (i - 1))
      i = Len(indata) + 1
    End If
  Next i
  indata = xdata
  'must have been only parser or 1 character + parser
  If Len(indata) < 2 Then
    word = indata
    Exit Function
  End If
  'strip trailing parser
  xdata = ""
  For i = Len(indata) To 1 Step -1
    If Mid(indata, i, 1) <> parser Then
      xdata = Left(indata, i)
      i = 0
    End If
  Next i
  word = xdata
  Exit Function
End If




Select Case parser
'------------------------------------------------
Case " ", ""
'................................................
'compress out leading/stuffing spaces to operate in word mode
parser = " "
For i = 1 To Len(indata)
  n = Mid$(indata, i, 1)
  Select Case n
    Case " "
      Select Case f
        Case 0
        Case 1
          xdata = xdata + n
          f = 0
      End Select
    Case Else
      xdata = xdata + n
      f = 1
  End Select
Next i
'------------------------------------------------
Case Else
'................................................
'leave as is to operate in item mode
xdata = indata
'------------------------------------------------
End Select

Select Case pointer
  Case Is <= 0
    If xdata = "" Then
      word = "0"
      Exit Function
    End If
    If InStr(xdata, parser) = 0 Then
      word = "1"
      Exit Function
    End If
    tagcount = 1
    '......................................
    Do
    itemtag(tagcount) = InStr(lasttag + 1, xdata, parser)
    lasttag = itemtag(tagcount)
    tagcount = tagcount + 1
    Loop Until lasttag = 0
    '......................................
    lasttag = Len(xdata)
    itemtag(tagcount) = lasttag
    If Right$(xdata, 1) = parser Then
      tagcount = tagcount - 1
    End If
    word = Right$(Str$(tagcount - 1), Len(Str$(tagcount - 1)) - 1)
  Case Is > limit
    word = ""
  Case Else
    If (InStr(xdata, parser) = 0) And (pointer > 1) Then
      word = ""
      Exit Function
    End If
    If (InStr(xdata, parser) = 0) And (pointer = 1) Then
      word = xdata
      Exit Function
    End If
    '............................................
    Do
    tagcount = tagcount + 1
    itemtag(tagcount) = InStr(lasttag + 1, xdata, parser)
    lasttag = itemtag(tagcount)
    Loop Until (lasttag = 0) Or (tagcount = pointer + 1)
    itemtag(tagcount) = Len(xdata) + 1
    '............................................
    If (pointer > tagcount) Then
      word = ""
      Exit Function
    End If
    word = Mid$(xdata, itemtag(pointer - 1) + 1, itemtag(pointer) - itemtag(pointer - 1) - 1)
    Exit Function
End Select

End Function

Public Function acosine(aangle As Double) As Double

Select Case aangle
  Case Is <= -1
    acosine = 180
    Exit Function
  Case Is >= 1
    acosine = 0
    Exit Function
  Case Else
    acosine = (-Atn(aangle / Sqr(-aangle * aangle + 1)) + Pi / 2) * 180 / Pi
End Select

End Function

Public Function asine(aangle As Double) As Double

Select Case aangle
  Case Is <= -1
    asine = -90
    Exit Function
  Case Is >= 1
    asine = 90
    Exit Function
  Case Else
    asine = Atn(aangle / Sqr(-aangle * aangle + 1)) * 180 / Pi
End Select

End Function

Public Function atangent(aangle As Double) As Double

atangent = Atn(aangle) * 180 / Pi

End Function

Public Function cosine(aangle As Double) As Double

cosine = Cos(Pi * (aangle / 180))

End Function

Public Function anglep1p2(spx As Double, spy As Double, epx As Double, epy As Double) As Double
'DETERMINE ANGLE FROM SOME POINT [SP] TO ANOTHER POINT [EP]

Dim deltax As Double
Dim deltay As Double
Dim hpt As Double

deltax = epx - spx
deltay = epy - spy
hpt = Sqr(deltax ^ 2 + deltay ^ 2)

Select Case Sgn(asine(deltay / hpt))
  Case 0, 1
    anglep1p2 = acosine(deltax / hpt)
  Case -1
    anglep1p2 = 360 - acosine(deltax / hpt)
End Select

End Function

Public Function decibel(magnitude As Double) As Double
'CONVERT MAGNITUDE TO DB

decibel = Log(magnitude) / 0.115129255

End Function

Public Function exponent(rbase As Double, indata As Double) As Double
'RETURN THE EXPONENT, base (r) of indata

If indata = 0 Or rbase = 0 Then
  exponent = 0
  Exit Function
End If

exponent = Log(indata) / Log(rbase)

End Function

Public Function logbase10(indata As Double) As Double

If indata <= 0 Then
  logbase10 = 0
  Exit Function
End If

logbase10 = Log(indata) / Log(10#)

End Function

Public Function magnitude(decibel As Double) As Double
'CONVERT DB TO MAGNITUDE

magnitude = Exp(2.3025851 * decibel / 20)

End Function

Public Function sine(aangle As Double) As Double

sine = Sin(Pi * (aangle / 180))

End Function

Public Function tangent(aangle As Double) As Double

tangent = Int(Tan(Pi * (aangle / 180)) * 1000000000000# + 0.5) / 1000000000000#

End Function



Public Function hextodec(datain As String) As Long
'FUNCTION HEXTODEC (datain)
'CONVERT HEXADECIMAL STRING TO DECIMAL
'
'WHEN PARSING BYTES, USE THE FOLLOWING FORMULAS:
'
'    B01& = HEXTODEC&(AZGOTO$)
'  B0% = (B01& AND 65280) / 256  'USE 3840 TO GET "xF" ETC
'  B1% = B01& AND 255
'limit is 31 bits +sign

Dim hexin As String
Dim lhex As Integer
Dim result As Long
Dim i As Integer
Dim hexdata As String
Dim decdata As Long

hexin = word(UCase$(datain), 1, "")
lhex = Len(hexin)

result = 0
For i = 1 To lhex
  hexdata = Mid$(hexin, lhex - i + 1, 1)
    Select Case hexdata
      Case "0" To "9"
        decdata = 16 ^ (i - 1) * Val(hexdata)
      Case "A" To "F"
        decdata = 16 ^ (i - 1) * (Asc(hexdata) - 55)
    End Select
  result = result + decdata
Next i

hextodec = result

End Function

Public Function fileexist(filenametotest As String) As Integer

On Error GoTo fileexisterr

If filenametotest = "" Then
  fileexist = 0
  Exit Function
End If

Select Case Dir(filenametotest, 0)
  Case ""
    'file does not exist
    fileexist = 0
  Case Else
    'file does exist
    fileexist = -1
End Select

Exit Function

fileexisterr:
fileexist = 0

End Function





Public Function dircleanup(dirin As String) As String

Dim f As Integer
Dim X As String
Dim Y As String
Dim n As String * 1
Dim i As Integer

'************************************************************

'remove all spaces from directory
X = word(UCase$(dirin), 1, "")

If X = "" Then
  dircleanup = ""
  Exit Function
End If

'remove multiple \ from inside of dir name
Y = Left$(X, 1)
For i = 2 To Len(X)
  n = Mid$(X, i, 1)
  Select Case n
    Case "\"
      Select Case f
        Case 0
        Case 1
          Y = Y + n
          f = 0
      End Select
    Case "A" To "Z", "0" To "9", "_", ":"
      Y = Y + n
      f = 1
    Case Else
      f = 0
  End Select
Next i

If Right$(Y, 1) = "\" Then Y = Left$(Y, Len(Y) - 1)

dircleanup = Y

End Function


Public Function filecleanup(filenme As String, fmode As Integer) As String
'mode   0   root.ext
'       1   root
'       2   ext
'       3   path
'       4   path\root.ext
'       5   path\root


Dim pn As Integer
Dim rn As Integer
Dim en As Integer
Dim ef As Integer
'------------------------------------------------------------
Dim p As String
Dim R As String
Dim e As String
Dim s As String
'------------------------------------------------------------
Dim Y As String
Dim n As String * 1
Dim i As Integer

'************************************************************

'skip processing no names
If Len(filenme) = 0 Then
  filecleanup = ""
  Exit Function
End If

'strip leading and trailing spaces from filename
For i = 1 To Len(filenme)
  Select Case Mid(filenme, i, 1)
    Case " "
    Case Else
      filenme = Mid(filenme, i, Len(filenme))
      i = Len(filenme) + 1
  End Select
Next i
For i = Len(filenme) To 1 Step -1
  Select Case Mid(filenme, i, 1)
    Case " "
    Case Else
      filenme = Mid(filenme, 1, i)
      i = 0
  End Select
Next i

'remove illegal characters from file name
Y = ""
For i = 1 To Len(filenme)
  n = Mid(filenme, i, 1)
  Select Case n
    Case "/", "*", "?", "<", ">", "|"
    Case Else
      Y = Y + n
  End Select
Next i

'create filname parser pointers
For i = 1 To Len(Y)
  n = Mid(filenme, i, 1)
  Select Case n
    Case "\"
      pn = i
    Case "."
      Select Case en
        Case 0
          en = i
        Case Else
          If ef = 0 Then ef = i
      End Select
    Case Else
  End Select
Next i

'remove anything after a second "."
If ef > 0 Then
  Y = Left(Y, ef - 1)
End If

'parse out pathname
Select Case pn
  Case 0
  Case Else
    p = Mid(Y, 1, pn - 1)
End Select

'parse out root and extension
Select Case en
  Case 0
    R = Mid(Y, pn + 1, Len(Y))
    e = ""
    s = ""
  Case Else
    R = Mid(Y, pn + 1, en - pn - 1)
    e = Mid(Y, en + 1, Len(Y))
    s = "."
End Select

'return requested data
Select Case fmode
  Case 0
    'return root+ext
    filecleanup = R + s + e
  Case 1
    'return root
    filecleanup = R
  Case 2
    'return ext
    filecleanup = e
  Case 3
    'return path
    filecleanup = p
  Case 4
    filecleanup = p + "\" + R + s + e
  Case 5
    filecleanup = p + "\" + R
End Select

End Function

Public Sub inidata(inimode As String)
'mode is "load" or "save"  >>>>>>>>do not use index 0<<<<<<<
'ini(100) defined in this module
'
'call inidata("load") in form load event
'call inidata("save") in form querry unload event
'
'for values of INI(x), x=1 to 100 (index 0 not used)!

Dim i As Integer
Dim X As Integer
Dim Y As String

X = FreeFile
Y = App.Path + "\" + App.EXEName + ".ini"

Select Case LCase(inimode)
  Case "load"
    'load ini data array from file
    'if exists and is [0] len then make len > 0
    'if not exists then make dummy file
    If fileexist(Y) Then
      If FileLen(Y) = 0 Then
        Open Y For Output As #X
        Print #X, ""
        Print #X, ""
        Close #X
      End If
    End If
    If (Not fileexist(Y)) Then
      Open Y For Output As #X
      Print #X, ""
      Print #X, ""
      Close #X
    End If
    Open Y For Input As #X
    i = 0
    Do
      i = i + 1
      Line Input #X, ini(i)
    Loop Until (i = 100) Or EOF(X)
    Close #X
  Case "save"
    'save ini data array to file
    SetAttr Y, vbNormal
    Open Y For Output As #X
    For i = 1 To 100
      Print #X, ini(i)
    Next i
    Close #X
End Select

End Sub

Public Function fill(datain As String, flen As Integer) As String

fill = Left$(datain + String$(flen, 32), 32)

End Function

Public Function pack(datain As String) As String

Dim i As Integer

For i = Len(datain) To 1 Step -1
  If Mid$(datain, i, 1) <> " " Then
    pack = Left$(datain$, i)
    Exit Function
  End If
Next i

pack = ""

End Function

Public Function getfilename(currentfile As String, filemask As String, startdirectory As String, fcaption As String) As String
'**************************************************
'if no start directory, extract from file name
'if no path in filename, use system current
'if multi-file select does not work then be sure to call "initstrings" from form load
'
'calls the filebox form and returns lists of files in comma delimited format
'if only one file is gotten, no processing required, if more than one then use "word" function
'to extract
'**************************************************
Dim sdir As String
Dim fmask As String
Dim tempfile As String

If startdirectory = "" Then
  If filecleanup(currentfile, 3) > "" Then
    sdir = filecleanup(currentfile, 3)
  Else
    sdir = CurDir
  End If
Else
  sdir = startdirectory
End If

If Not direxist(sdir) Then
  sdir = App.Path
End If

'if no filemask then use all
If filemask = "" Then
  fmask = "*.*"
Else
  fmask = filemask
End If

'change to the currently specified drive
ChDrive sdir

Load selectfile

selectfile.filelist.Pattern = fmask
selectfile.filelist.Path = sdir
selectfile.dirlist.Path = sdir
selectfile.filename = currentfile
selectfile.Caption = fcaption

selectfile.Show 1

Select Case selectfile.filename
  Case ""
    getfilename = ""
  Case Else
    Select Case Right(selectfile.dirlist.Path, 1)
      Case "\"
        'root of current drive
        getfilename = selectfile.dirlist.Path + selectfile.filename
      Case Else
        'not the root directory
        tempfile = selectfile.dirlist.Path + "\" + selectfile.filename
        'replace cr/lf of multi select with ", "
        If InStr(1, tempfile, cr) > 0 Then
          Do
            If InStr(1, tempfile, cr) > 0 Then
              Mid(tempfile, InStr(1, tempfile, cr), 1) = " "
            End If
            If InStr(1, tempfile, lf) > 0 Then
              Mid(tempfile, InStr(1, tempfile, lf), 1) = ","
            End If
          Loop Until (InStr(1, tempfile, cr) = 0) And (InStr(1, tempfile, lf) = 0)
          getfilename = tempfile
        Else
          getfilename = tempfile
        End If
    End Select
End Select
ChDir selectfile.dirlist.Path
ChDrive Left$(selectfile.dirlist.Path, 1)

Unload selectfile

End Function



Public Sub initstrings()

tb = Chr(9)
lf = Chr(10)
ff = Chr(12)
cr = Chr(13)
es = Chr(27)
qt = Chr(34)
bs = Chr(8)
dl = Chr(127)
nl = cr + lf
ack = Chr(6)
nack = Chr(21)

'serial port default strings for ascii transfers
'startchar = "!"
'endchar = cr

End Sub


Public Function engnotation(datain As Double, unitbase As String) As String

Dim a As String
Dim b As String
Dim i As Double

'************************************************************

Select Case datain
  Case Is < 0.00000001
    a = " n"
    i = 1000000000#
  Case Is < 0.00001
    a = " u"
    i = 1000000#
  Case Is < 0.01
    a = " m"
    i = 1000
  Case Is < 10
    a = " "
    i = 1
  Case Is < 10000
    a = " k"
    i = 0.001
  Case Is < 10000000
    a = " M"
    i = 0.000001
  Case Else
    a = " "
    i = 1
End Select

b = Str(Int(1000 * datain * i))
b = Right("0000" + Right(b, Len(b) - 1), 4)
engnotation = Left(b, 1) + "." + Right(b, 3) + a + unitbase

End Function

Public Function direxist(dirtotest As String) As Integer

On Error GoTo direxisterr

If dirtotest = "" Then
  direxist = 0
  Exit Function
End If

Select Case Dir(dirtotest, vbDirectory)
  Case ""
    'directory does not exist
    direxist = 0
  Case Else
    'directory does exist
    direxist = -1
End Select
Exit Function

direxisterr:
direxist = 0
On Error GoTo 0

End Function

Public Function log10(X) As Double

If X <= 0 Then
  log10 = 0
  Exit Function
End If

log10 = Log(X) / Log(10#)

End Function

Public Function nformat(indata As Double, decimals As Integer) As String
'generate non space loaded string data for right justified text boxes
'negative numbers will have sign added

Dim xdata As String
Dim ydata As String
Dim sign As String  'do the sign later, work on abs value
Dim pad As Boolean  'for numbers less than 1, multiplying doesn't create good string from number
Dim temp As Double

'*****************************************************************
'deal with input=0.0

If indata = 0 Then
  If decimals = 0 Then
    nformat = "0"
  Else
    nformat = "0." + String(decimals, "0")
  End If
  Exit Function
End If

'not zero so save and remove sign
If indata < 0 Then sign = "-"
indata = Abs(indata)


If (Log(indata) / Log(10)) + decimals > 14 Then
  nformat = "Error"
  Exit Function
End If



'deal with input<1 and >0 and no decimals requested
If (indata < 1) And (decimals = 0) Then
  temp = Int(indata + 0.5)
  If temp = 0 Then
    nformat = sign + "0"
    Exit Function
  Else
    nformat = sign + "1"
    Exit Function
  End If
End If

'decimals greater than zero, so deal with deciamls only (no integers)
If indata < 1 Then
  pad = True
  indata = indata + 1
End If

Select Case decimals
  Case 0
    xdata = Str(Int(indata))
    nformat = sign + Right(xdata, Len(xdata) - 1)
  Case Else
    xdata = Str(Int((indata * (10 ^ decimals)) + 0.99999999))
    ydata = Right(xdata, decimals)
    If pad = True Then
      xdata = "0"
    Else
      xdata = Str(Int(indata))
      xdata = Right(xdata, Len(xdata) - 1)
    End If
    nformat = sign + xdata + "." + ydata
End Select

End Function



Public Function showalert(acaption As String, amessage As String) As Boolean

Dim R As Boolean

Load alert

Beep

alert.Caption = acaption
alert.message = amessage
alert.Show 1

R = alert.respond.Value

Unload alert

showalert = R

End Function

Public Function xsplit(inarray() As String, instring As String, delimit As String) As Integer

Dim xarray() As String

xarray() = Split(instring, delimit)

If UBound(xarray) = -1 Then
  xsplit = 0
  Exit Function
End If

ReDim inarray(UBound(xarray()))

inarray() = xarray()

xsplit = UBound(xarray())

End Function

Public Function exedir() As String

exedir = App.Path

End Function

Public Sub delay(hundredths As Integer)

Dim newtime As Single

'////////////////////////////////////////////////////////////////////////

newtime = Timer + (hundredths / 100)
If (newtime - Timer) > 300000 Then Exit Sub

Do
DoEvents
Loop While newtime >= Timer


End Sub


Public Function respframer(startchar As String, endchar As String) As String
'returns first frame between start and end characters from public rxbuffer
'does not strip off start or end character
'throws away any no frame data before first start character
'call repeatedly to handle multiple response blocks
'
'allows start and end framers to be multi-characters

Dim startpos As Integer
Dim endpos As Integer

startpos = InStr(1, rxbuffer, startchar)
If startpos = 0 Then
    respframer = ""
    Exit Function
End If

endpos = InStr(startpos + Len(startchar) + 1, rxbuffer, endchar)
If endpos = 0 Then
    respframer = ""
    Exit Function
End If

respframer = Mid(rxbuffer, startpos, endpos - startpos + Len(endchar))
rxbuffer = Mid(rxbuffer, endpos + Len(endchar), Len(rxbuffer))

End Function


Public Function math32(param1s As String, operation As String, param2s As String) As String
'32 bit unsigned integer math on string variables
'param1() [operation] param2() >> dest()
'
'available operations:
'------------------------------------------------------
'add
'sub
'not        uses only parameter 1
'xor
'and
'or
'sright     Shift right param2 bits, 0 shifted in
'sleft      Left
'rright     Rotate right (param2) bits, LSB>>MSB
'rleft      Left,` LSB<<MSB



Dim carry As Integer

Dim i As Integer
Dim j As Integer

Dim param1x As String
Dim param2x As String

Dim param1(3) As Integer
Dim param2(3) As Integer
Dim result(3) As Integer

Dim accum As Integer

Dim xres As String
'/////////////////////////////////////////////////////////////////////////////////
xres = ""
For i = 1 To Len(param1s)
  Select Case UCase(Mid(param1s, i, 1))
    Case "A" To "F", "0" To "9"
      xres = xres + UCase(Mid(param1s, i, 1))
  End Select
Next i
param1x = Right("00000000" + xres, 8)


xres = ""
For i = 1 To Len(param2s)
  Select Case UCase(Mid(param2s, i, 1))
    Case "A" To "F", "0" To "9"
      xres = xres + UCase(Mid(param2s, i, 1))
  End Select
Next i
param2x = Right("00000000" + xres, 8)

xres = ""

'convert strings to bytes
For i = 0 To 3
  param1(3 - i) = hextodec(Mid(param1x, i * 2 + 1, 2))
  param2(3 - i) = hextodec(Mid(param2x, i * 2 + 1, 2))
Next i


Select Case LCase(operation)
  Case "add"
    carry = 0
    For i = 0 To 3
        accum = param1(i) + param2(i) + carry
        result(i) = accum And 255
        carry = (accum And 256) / 256
    Next i
  Case "xor"
    For i = 0 To 3
      result(i) = param1(i) Xor param2(i)
    Next i
  Case "and"
    For i = 0 To 3
      result(i) = param1(i) And param2(i)
    Next i
  Case "or"
    For i = 0 To 3
      result(i) = param1(i) Or param2(i)
    Next i
  Case "not"
    For i = 0 To 3
      result(i) = param1(i) Xor 255
    Next i
  Case "sub"
    'a-b = a+!b+1
    For i = 0 To 3
      result(i) = param2(i) Xor 255
    Next i
    carry = 1
    For i = 0 To 3
        accum = param1(i) + result(i) + carry
        result(i) = accum And 255
        carry = (accum And 256) / 256
    Next i
  Case "sright"
    If param2(0) > 32 Then param2(0) = 32
    For j = 1 To param2(0)
      For i = 0 To 3
        param1(i) = (param1(i) And &HFE) / 2
        If (i < 3) Then
          If ((param1(i + 1) And 1) = 1) Then
            param1(i) = param1(i) + 128
          End If
        End If
      Next i
    Next j
    For i = 0 To 3
      result(i) = param1(i)
    Next i
  Case "sleft"
    If param2(0) > 32 Then param2(0) = 32
    For j = 1 To param2(0)
      For i = 3 To 0 Step -1
        param1(i) = (param1(i) And &H7F) * 2
        If (i > 0) Then
          If ((param1(i - 1) And 128) = 128) Then
            param1(i) = param1(i) + 1
          End If
        End If
      Next i
    Next j
    For i = 0 To 3
      result(i) = param1(i)
    Next i
  Case "rright"
    If param2(0) > 32 Then param2(0) = 32
    For j = 1 To param2(0)
      carry = param1(0) And 1
      For i = 0 To 3
        param1(i) = (param1(i) And &HFE) / 2
        If (i < 3) Then
          If ((param1(i + 1) And 1) = 1) Then
            param1(i) = param1(i) + 128
          End If
        Else
          If carry = 1 Then
            param1(i) = param1(i) + 128
          End If
        End If
      Next i
    Next j
    For i = 0 To 3
      result(i) = param1(i)
    Next i
  Case "rleft"
    If param2(0) > 32 Then param2(0) = 32
    For j = 1 To param2(0)
      carry = param1(3) And 128
      For i = 3 To 0 Step -1
        param1(i) = (param1(i) And &H7F) * 2
        If (i > 0) Then
          If ((param1(i - 1) And 128) = 128) Then
            param1(i) = param1(i) + 1
          End If
        Else
          If carry = 128 Then
            param1(i) = param1(i) + 1
          End If
        End If
      Next i
    Next j
    For i = 0 To 3
      result(i) = param1(i)
    Next i

End Select


For i = 0 To 3
  xres = Right("00" + Hex(result(i)), 2) + xres
Next i


math32 = xres


End Function

Public Function hexed(datain, outputlen) As String

Dim temp As String

hexed = Right("0000000000" + Hex(datain), outputlen)

End Function

Public Function appversion() As String
Dim majornum As String
Dim minornum As String
Dim revnum As String

majornum = Right(Str(App.Major), Len(Str(App.Major)) - 1)
minornum = Right("00" + Right(Str(App.Minor), Len(Str(App.Minor)) - 1), 2)
revnum = Right("00" + Right(Str(App.Revision), Len(Str(App.Revision)) - 1), 2)

appversion = majornum + "." + minornum + "." + revnum

End Function
